// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------

// GSedgeDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "GSedge.h"
#include "GSedgeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGSedgeDlg _CAO

CGSedgeDlg::CGSedgeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGSedgeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGSedgeDlg)
	m_searchmode = -1;
	m_precision = -1;
	m_condition = 5;
	m_threshold = 60;
	m_middlethreshold = 50;
	m_gswndtouch = FALSE;
	m_edgecolor = -1;
	m_edgestartpos = -1;
	m_edgepoint = -1;
	m_edgethreshold = 50;
	m_linewidth = 0;
	m_disp = NULL;
	m_result = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGSedgeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGSedgeDlg)
	DDX_CBIndex(pDX, IDC_SEARCHMODE, m_searchmode);
	DDX_CBIndex(pDX, IDC_PRECISION, m_precision);
	DDX_Text(pDX, IDC_CONDITION, m_condition);
	DDV_MinMaxInt(pDX, m_condition, 1, 9);
	DDX_Text(pDX, IDC_THRESHOLD, m_threshold);
	DDV_MinMaxInt(pDX, m_threshold, 10, 99);
	DDX_Text(pDX, IDC_MIDDLETHRESHOLD, m_middlethreshold);
	DDV_MinMaxInt(pDX, m_middlethreshold, 10, 99);
	DDX_Check(pDX, IDC_GSWNDTOUCH, m_gswndtouch);
	DDX_CBIndex(pDX, IDC_EDGECOLOR, m_edgecolor);
	DDX_CBIndex(pDX, IDC_EDGESTARTPOS, m_edgestartpos);
	DDX_CBIndex(pDX, IDC_EDGEPOINT, m_edgepoint);
	DDX_Text(pDX, IDC_EDGETHRESHOLD, m_edgethreshold);
	DDV_MinMaxInt(pDX, m_edgethreshold, 0, 100);
	DDX_Text(pDX, IDC_LINEWIDTH, m_linewidth);
	DDV_MinMaxInt(pDX, m_linewidth, 0, 99999);
	DDX_Text(pDX, IDC_RESULT, m_result);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGSedgeDlg, CDialog)
	//{{AFX_MSG_MAP(CGSedgeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SETEDGESCANLINE, OnSetedgescanline)
	ON_BN_CLICKED(IDC_SETSTANDARD, OnSetstandard)
	ON_BN_CLICKED(IDC_DISPPATTERN1, OnDisppattern1)
	ON_BN_CLICKED(IDC_DISPPATTERN2, OnDisppattern2)
	ON_BN_CLICKED(IDC_SETPATTERNMASK1, OnSetpatternmask1)
	ON_BN_CLICKED(IDC_SETPATTERNMASK2, OnSetpatternmask2)
	ON_BN_CLICKED(IDC_SAVEPATTERN1, OnSavepattern1)
	ON_BN_CLICKED(IDC_SAVEPATTERN2, OnSavepattern2)
	ON_BN_CLICKED(IDC_LOADPATTERN1, OnLoadpattern1)
	ON_BN_CLICKED(IDC_LOADPATTERN2, OnLoadpattern2)
	ON_BN_CLICKED(IDC_SETPATTERN1, OnSetpattern1)
	ON_BN_CLICKED(IDC_SETPATTERN2, OnSetpattern2)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeregion)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_DOSAMPLE, OnDosample)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGSedgeDlg bZ[W nh

BOOL CGSedgeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		long err_no ;

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_FvxROI1.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxROI2.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) ); 
		m_FvxPattern1.CreateInstance( __uuidof( FvxPattern ) ); 
		m_FvxPattern2.CreateInstance( __uuidof( FvxPattern ) ); 
		m_FvxEdge.CreateInstance( __uuidof( FvxEdge ) ); 
		m_FvxCalcData.CreateInstance( __uuidof( FvxCalcData ) ); 

		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 
		m_pStandardPoint.CreateInstance( __uuidof( FvPoint ) ); 
		m_pEdgeScanLine.CreateInstance( __uuidof( FvLineSegment ) ); 

		// J荞ݖ
		GetDlgItem( IDC_GRAB )->EnableWindow( FALSE );
		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// fBXvC
	    m_disp = new CDisplay();
		m_disp->Create( IDD_DISPLAY , GetDesktopWindow() );
		m_disp->ShowWindow( SW_HIDE );

		// fBXvC̏
		m_disp->m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// ͈͂̏lݒ(摜̑Sʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putye( -1 );
		
		// GbWoC̏lݒ
		m_pEdgeScanLine->Putxs( 300 );
		m_pEdgeScanLine->Putxe( 250 );
		m_pEdgeScanLine->Putys( 400 );
		m_pEdgeScanLine->Putye( 250 );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_SEARCHMODE );
		pcmb->AddString( "ʏ̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "̃p^[" );
		pcmb->AddString( "sp^[" );
		m_searchmode = 0 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_PRECISION );
		pcmb->AddString( "ʏ퐸x" );
		pcmb->AddString( "x" );
		pcmb->AddString( "x" );
		m_precision = 0 ;
		
		pcmb = ( CComboBox* )GetDlgItem( IDC_EDGECOLOR );
		pcmb->AddString( "" );
		pcmb->AddString( "" );
		pcmb->AddString( "ɐ" );
		m_edgecolor = 2 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_EDGESTARTPOS );
		pcmb->AddString( "ő_" );
		pcmb->AddString( "ŏ̓_" );
		pcmb->AddString( "ɐ" );
		m_edgestartpos = 0 ;

		pcmb = ( CComboBox* )GetDlgItem( IDC_EDGEPOINT );
		pcmb->AddString( "n_I_" );
		pcmb->AddString( "I_n_" );
		m_edgepoint = 0 ;

		UpdateData(FALSE); 
		
		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {

			// rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage1 );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage1 );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem( IDC_GRAB )->EnableWindow( TRUE );
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	UpdateData(FALSE); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CGSedgeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CGSedgeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// fBXvC\
		m_disp->ShowWindow( SW_SHOW );
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CGSedgeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CGSedgeDlg::DestroyWindow() 
{

	// DisplayJ
	if ( m_disp!=NULL ) {
		m_disp->DestroyWindow();
		delete m_disp;
		m_disp = NULL;
	}

	// rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
	return CDialog::DestroyWindow();
}

void CGSedgeDlg::OnSetedgescanline() 
{
    
    // ݒ_CAȌl߂Ă܂
    m_FvxROI2->InitPoint();
    m_FvxROI2->InitRectangle();
    m_FvxROI2->SetLineSegment( m_pEdgeScanLine );
    
    // FvxROIgČoI_CAOo܂
    m_FvxROI2->PutUseLineSegment( TRUE );
    m_FvxROI2->PutUsePoint( FALSE );
    m_FvxROI2->PutUseRectangle( FALSE );
    
	long lngOK = 0;
    m_FvxROI2->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1  ) && (  m_FvxROI2->GetCheckLineSegment() == 1 )) {
		m_FvxROI2->GetLineSegment( m_pEdgeScanLine );
	}

}

// Rg[ɓ͂ꂽݒlKp
int CGSedgeDlg::ApplyChanges()
{

    // p[^G[ꍇ Ԓl = -1
	if (!UpdateData(TRUE)) return -1;

    // p[^ݒ
    m_FvxCorrelation->SetInspectArea( m_ExeRegion );				  // ͈
    m_FvxCorrelation->PutSearchMode( (SEARCH_MODE_TYPE)m_searchmode );   // T[`[hiׂȂǂ̃p^[Ɏgpj
    m_FvxCorrelation->PutPrecision( (PRECISION_TYPE)m_precision );	  // T[`
    
    // 摜̏
    
    if (( m_condition < 1 ) || ( m_condition > 9 )) {
		MessageBox("摜Ԃ 1`9 ̊ԂŐݒ肵ĂB" , "G[" , MB_ICONWARNING | MB_OK );
		return -1;
	}
	m_FvxCorrelation->PutCondition( m_condition );
    
    // 臒l
    if (( m_threshold < 10 ) || ( m_threshold > 1000 )) {
		MessageBox("臒l 10`100 ̊Ԃœ͂ĂB" , "G[" , MB_ICONWARNING | MB_OK );
		return -1;
	}
	m_FvxCorrelation->PutScoreThresh( m_threshold );
    
    // r臒l
	if (( m_middlethreshold < 10 ) || ( m_middlethreshold > 1000 )) {
		MessageBox("r臒l 10`100 ̊Ԃœ͂ĂB" , "G[" , MB_ICONWARNING | MB_OK );
		return -1;
	}
	m_FvxCorrelation->PutScoreThresh2( m_middlethreshold );
    
    // T[`
    m_FvxCorrelation->PutSearchNum( 1 );
    
    // ͈͐ڐGĂ̂o邩
    if ( m_gswndtouch == TRUE  ) {
        m_FvxCorrelation->PutWindowTouch( ON );
	} else {
		m_FvxCorrelation->PutWindowTouch( OFF );
	}
    
    // 臒l
	if (( m_edgethreshold < 0 ) || ( m_edgethreshold > 100 )) {
		MessageBox("臒l 0`100 ̊ԂŐݒ肵ĂB" , "G[" , MB_ICONWARNING | MB_OK );
		return -1;
	}
	m_FvxEdge->PutThresh( m_edgethreshold );
    
    // Е
    if ( m_linewidth < 0  ) {
		MessageBox("Е͂OȏŐݒ肵ĂB" , "G[" , MB_ICONWARNING | MB_OK );
		return -1;
	}
	m_FvxEdge->PutLineWidth( m_linewidth );
    
    m_FvxEdge->PutEdgeColor( (EDGE_COLOR_TYPE )m_edgecolor );			  // GbWɐ
    m_FvxEdge->PutStartPosition( (START_POSITION_TYPE )m_edgestartpos );  // o
    m_FvxEdge->PutEdgePoint( (EDGE_POINT_TYPE )m_edgepoint );			  // GbWʒu
    
    // G[
	return 0;

}

// Q̓o^p^[ɂāAT[`s
// Ԓl  I=0 , ُI(p^[Ȃetc)=-1
int CGSedgeDlg::Search(IFvSearchResultPtr pGSResult0, IFvSearchResultPtr pGSResult1)
{
	// ep[^̓Kp
    if ( ApplyChanges() == -1 ) return -1;
    
    // p^[PT[`s
    long lngCount = 0;

	try {
		m_FvxCorrelation->SetPattern( m_FvxPattern1 );
		m_FvxCorrelation->Execute( m_FvxImage1, &lngCount );
    
		if ( lngCount == 1 ) {
			m_FvxCorrelation->GetResult( 0, pGSResult0 );
    
			// p^[QT[`s
			m_FvxCorrelation->SetPattern( m_FvxPattern2 );
			m_FvxCorrelation->Execute( m_FvxImage1, &lngCount );
    
			if ( lngCount == 1 ) {
				m_FvxCorrelation->GetResult( 0 , pGSResult1 );
				// p^[QƂԒl = 0
				return 0;
			} else {
				MessageBox("p^[Q܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return -1;
			}
		} else {
			MessageBox("p^[P܂B" , "G[" , MB_ICONWARNING | MB_OK );
			return -1;
		}

	} catch(_com_error ) {
	
	    long lngErr = 0;
		CString str;
		m_FvxCorrelation->GetErrReport( &lngErr );

		switch (lngErr ) {
			case 0:
				str = "G[";
				break;
			case 5001:
				str = "p^݂Ă܂B";
				break;
			case 5005:
				str = "p[^Ⴂ܂B";
				break;
			case 5006:
				str = "^Ⴂ܂B";
				break;
			case 5007:
				str = "p^摜̂߁Ao^ł܂B";
				break;
			case 5008:
				str = "p^ƃ}XÑTCYvĂ܂B";
				break;
			case 5009:
				str = "p[^NULLlw肳܂B";
				break;
			case 5010:
				str = "p[^NULLlw肳܂B";
				break;
			case 5022:
				str = "p^w肳Ă܂B";
				break;
			default:
				str = "sȃG[";
				break;
		}
		return -1;
	}	
}

// lpɏ\̃}[N\
void CGSedgeDlg::DrawPointMark(IFvPointPtr pPoint)
{
    
	IFvRectangle2Ptr pBox ( __uuidof( FvRectangle ));
    IFvLineSegmentPtr pLineSeg ( __uuidof( FvLineSegment ));

    pBox->Putxs( pPoint->Getx() - 3 );
    pBox->Putys( pPoint->Gety() - 3 );
    pBox->Putxe( pPoint->Getx() + 3 );
    pBox->Putye( pPoint->Gety() + 3 );
	m_disp->m_FvxDisplayEx->DrawData( 0, pBox );
    
    pLineSeg->Putxs( pPoint->Getx() - 8 );
    pLineSeg->Putxe( pPoint->Getx() + 8 );
    pLineSeg->Putys( pPoint->Gety() );
    pLineSeg->Putye( pPoint->Gety() );
	m_disp->m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
    pLineSeg->Putxs( pPoint->Getx() );
    pLineSeg->Putxe( pPoint->Getx() );
    pLineSeg->Putys( pPoint->Gety() - 8 );
    pLineSeg->Putye( pPoint->Gety() + 8 );
	m_disp->m_FvxDisplayEx->DrawData( 0, pLineSeg );
    
}

// T[`sāǍʂƂĕۑ
void CGSedgeDlg::OnSetstandard() 
{

    IFvSearchResultPtr pSearchResult0( __uuidof( FvSearchResult ));
    IFvSearchResultPtr pSearchResult1( __uuidof( FvSearchResult ));
	IFvLinePtr pLine( __uuidof( FvLine ));

	m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    
	// ep[^̓Kp
    if ( ApplyChanges() == -1 ) {
		return;
    }

    // ͈͂ŕ\
	m_disp->m_FvxDisplayEx->PutPenColor(RGB(0, 0, 255));
	m_disp->m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
    
    if ( Search(pSearchResult0, pSearchResult1) == 0 ) {
            
        // T[`ʂ͐Ԃŕ\
		m_disp->m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
        m_disp->m_FvxDisplayEx->PutPenColor(RGB(255, 0, 0));
        
        m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResult0 );
        m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResult1 );
    
        // Q̃T[`ʂ̒_ƁAxƂ̌p߂
        m_pStandardPoint->Putx((pSearchResult0->Getx() + pSearchResult1->Getx()) / 2 );
        m_pStandardPoint->Puty((pSearchResult0->Gety() + pSearchResult1->Gety()) / 2 );
        // px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
        // ̂߁A̒l͉EŐɂȂ܂B
        m_dblStandardAngle = ArcTan((pSearchResult1->Getx() - pSearchResult0->Getx()), (pSearchResult1->Gety() - pSearchResult0->Gety()));
        
        // Q̃T[`ʂ̒_Ƀ}[N\
        DrawPointMark( m_pStandardPoint );
        
        // FvxCalcDataR|[lg𗘗pāA
        // _ʂ钼̎߂
		m_FvxCalcData->CalcLine_TwoPoint( pSearchResult0, pSearchResult1 );
		m_FvxCalcData->CalcLine_GetResult( pLine );
			
		m_disp->m_FvxDisplayEx->PutPenColor( RGB(192, 192, 255) );
        m_disp->m_FvxDisplayEx->DrawData( 0, pLine );
        
        // GbWoC\
        m_disp->m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
        m_disp->m_FvxDisplayEx->DrawData( 0, m_pEdgeScanLine );
	}    

}

// -΁`΂܂ŌvZł悤Atng
double CGSedgeDlg::ArcTan(double dbl_x, double dbl_y)
{
	const double PI = 3.14159265358979;

    if ( dbl_x > 0 ) {
        return  atan(dbl_y / dbl_x);
	} else {
		if ( dbl_y > 0 ) {
            return  PI - atan(dbl_y / -dbl_x);
		} else {
			return atan (-dbl_y / -dbl_x) - PI;
		}
	}

}

void CGSedgeDlg::OnDisppattern1() 
{
	m_FvxPattern1->Disp(-1,-1);
}
void CGSedgeDlg::OnDisppattern2() 
{
	m_FvxPattern2->Disp(-1,-1);
}
void CGSedgeDlg::OnSetpatternmask1() 
{
	m_FvxPattern1->DefMask(-1,-1);
}
void CGSedgeDlg::OnSetpatternmask2() 
{
	m_FvxPattern2->DefMask(-1,-1);
}

// p^[t@C̕ۑ
void CGSedgeDlg::OnSavepattern1() 
{
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂
	char szFilters[]="bitmap file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {

			m_FvxPattern1->PutSavePattrenFileName (_bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern1->Save();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern1->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

void CGSedgeDlg::OnSavepattern2() 
{
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂
	char szFilters[]="bitmap file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {

			m_FvxPattern2->PutSavePattrenFileName (_bstr_t( cFileDlg.GetPathName() ));
			m_FvxPattern2->Save();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern2->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// p^[t@C̓Ǎ
void CGSedgeDlg::OnLoadpattern1() 
{
	// R_CAONX̐
    // p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
    // "pat"gp邱Ƃ𐄏܂

	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxPattern1->PutLoadPattrenFileName(_bstr_t( cFileDlg.GetPathName()));
			m_FvxPattern1->Load();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern1->GetErrReport( &lngErr );
			cStr.Format("p^[ǍݎsBerr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// p^[t@C̓Ǎ
void CGSedgeDlg::OnLoadpattern2() 
{
	// R_CAONX̐
    // p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
    // "pat"gp邱Ƃ𐄏܂

	char szFilters[]="pat file(*.pat)|*.pat||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "pat", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		try {
		
			m_FvxPattern2->PutLoadPattrenFileName(_bstr_t( cFileDlg.GetPathName()));
			m_FvxPattern2->Load();
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxPattern2->GetErrReport( &lngErr );
			cStr.Format("p^[ǍݎsBerr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// p^[o^
void CGSedgeDlg::OnSetpattern1() 
{
	OnSetpattern(1);
}
// p^[o^
void CGSedgeDlg::OnSetpattern2() 
{
	OnSetpattern(2);
}
// p^[o^
void CGSedgeDlg::OnSetpattern(int index)
{

    IFvRectangle2Ptr pRect(__uuidof(FvRectangle));  // p^[̈̐ݒ
	IFvPointPtr pPoint(__uuidof(FvPoint));			// p^[_
    // o^̏`ݒ
    m_FvxROI1->InitPoint();
    m_FvxROI1->InitRectangle();
    m_FvxROI1->InitLineSegment();
    m_FvxROI1->PutUsePoint( TRUE );
    m_FvxROI1->PutUseRectangle( TRUE );
    m_FvxROI1->PutUseLineSegment( FALSE );
    pRect->Putxs( 100 );
    pRect->Putys( 100 );
    pRect->Putxe( 200 );
    pRect->Putye( 200 );
    m_FvxROI1->SetRectangle( pRect );
    
    // FvxROIgď͈͑I_CAOo܂
	long lngOK = 0; 
    m_FvxROI1->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI1->GetCheckRectangle() == 1 ) ) {
		m_FvxROI1->GetRectangle( pRect );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
        double dblTemp = 0;
		if ( pRect->Getxe() < pRect->Getxs()) {
            dblTemp = pRect->Getxs();
            pRect->Putxs( pRect->Getxe() );
            pRect->Putxe( dblTemp );
		}
		if ( pRect->Getye() < pRect->Getys()) {
            dblTemp = pRect->Getys();
            pRect->Putys( pRect->Getye() );
            pRect->Putye( dblTemp );
		}
			
        if (( m_FvxROI1->GetCheckPoint() == 1 )) {
            m_FvxROI1->GetPoint( pPoint );
        } else {
			MessageBox("p^[_w肳܂łB\r\np^[`̒S_Ƃēo^܂","p^[o^", MB_ICONWARNING | MB_OK);
            pPoint->Putx((pRect->Getxs() + pRect->Getxe()) / 2);
            pPoint->Puty((pRect->Getys() + pRect->Getye()) / 2);
		}

        if ( index == 1 ) {
			m_FvxPattern1->MakePattern( m_FvxImage1, pRect, pPoint );
		} else {
			m_FvxPattern2->MakePattern( m_FvxImage1, pRect, pPoint );
		}			
	}
}

// ͈͂̐ݒ
void CGSedgeDlg::OnExeregion() 
{
    
    m_FvxROI1->SetRectangle( m_ExeRegion );
    
    // FvxROIgď͈͑I_CAOo܂
    long lngOK = 0;
    m_FvxROI1->PutUsePoint( FALSE );
    m_FvxROI1->MakeROIDialog( m_FvxImage1, &lngOK );
    
    if (( lngOK == 1 ) && ( m_FvxROI1->GetCheckRectangle() == 1 )) {
		m_FvxROI1->GetRectangle( m_ExeRegion );
        
        // n_ƏI_tɂȂĂȂ`FbN܂
        // FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
        // tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ
	    double dblTemp = 0;
        if ( m_ExeRegion->Getxe() < m_ExeRegion->Getxs()) {
            dblTemp = m_ExeRegion->Getxs();
            m_ExeRegion->Putxs( m_ExeRegion->Getxe() );
            m_ExeRegion->Putxe( dblTemp );
		}
		if ( m_ExeRegion->Getye() < m_ExeRegion->Getys()) {
            dblTemp = m_ExeRegion->Getys();
            m_ExeRegion->Putys( m_ExeRegion->Getye() );
            m_ExeRegion->Putye( dblTemp );
		}
	}		
}

// J荞
void CGSedgeDlg::OnGrab() 
{
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage1 );
    
    // 捞
    m_FvxVideo->GrabSync( m_FvxImage1 );
    // 荞񂾉摜ʂɕ\
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
}

// 摜ۑ
void CGSedgeDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// 摜t@CǍ
void CGSedgeDlg::OnLoadimage() 
{
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImage1->GetImageType ()!=imageGray ) || ( m_FvxImage1->GetBitPerPixel()!=8 )) {

			MessageBox("OC摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage1->PutBitPerPixel( 8 );
            m_FvxImage1->PutImageType( imageGray );
            m_FvxImage1->PutImageWidth( 512 );
            m_FvxImage1->PutImageHeight( 480 );

		}
        m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	}	
}

// Yvs
void CGSedgeDlg::OnExecute() 
{

    // O[T[`̌
    IFvSearchResultPtr pSearchResult0(__uuidof(FvSearchResult));
    IFvSearchResultPtr pSearchResult1(__uuidof(FvSearchResult));
    IFvLinePtr pLine(__uuidof(FvLine));
	IFvLineSegmentPtr pScanLineSeg(__uuidof(FvLineSegment));  // W␳̃GbWoC
	IFvEdgeResultPtr pEdgeResult(__uuidof(FvEdgeResult));	  // GbW_o
    IFvPointPtr pNowPoint(__uuidof(FvPoint));				  // Q̃p^[̃T[`ʂ̊_񂾐̒_

	long lngCount = 0;			// GbW_̌
    double dblTime = 0;			// 
	CString sResult;

    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    
    m_result = "";
    
    // ep[^̓Kp
    if ( ApplyChanges() == -1 ) {
		return;
	}

    // ----------------------------------------------------------------
    // ԌvJn
    m_FvxPerformanceCounter->StartCount();
        
    // ͈͂ŕ\
    m_disp->m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
    m_disp->m_FvxDisplayEx->DrawData( 0, m_ExeRegion );
    
    if ( Search(pSearchResult0, pSearchResult1) == 0 ) {

        // T[`ʂ͐Ԃŕ\
	    m_disp->m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );
	    m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResult0 );
	    m_disp->m_FvxDisplayEx->DrawData( 0, pSearchResult1 );
        
        // Q̃T[`ʂ̒_ƁAxƂ̌p߂
        pNowPoint->Putx((pSearchResult0->Getx() + pSearchResult1->Getx()) / 2 );
        pNowPoint->Puty((pSearchResult0->Gety() + pSearchResult1->Gety()) / 2 );
        // px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
        // ̂߁A̒l͉EŐɂȂ܂B
        double dblNowAngle = ArcTan((pSearchResult1->Getx() - pSearchResult0->Getx()), (pSearchResult1->Gety() - pSearchResult0->Gety()));
        
        // Q̃T[`ʂ̒_Ƀ}[N\
        DrawPointMark( pNowPoint );

        // Ƃ̃YvZ
        double dblDiffX = pNowPoint->Getx() - m_pStandardPoint->Getx();
        double dblDiffY = pNowPoint->Gety() - m_pStandardPoint->Gety();
        double dblDiffAngle = m_dblStandardAngle - dblNowAngle;			// Ő̒lɂȂ悤vZ
		const double PI = 3.14159265358979;
        double dblDiffAnglePI = dblDiffAngle * 180 / PI;

		m_result.Format("Yw %.2f\r\nYx %.2f\r\nYpx %.2f",dblDiffX,dblDiffY,dblDiffAnglePI);
            
        // GbWoC̎n_W_𒆐SƂăYpx]
        // W͈ʂ̍WnƏ㉺tȂ̂ŁA]tɂB
        //
        //  = -dblDiffAngle
        //  | cos -sin || m_pEdgeScanLine.xs - m_pStandardPoint.x | + | m_pStandardPoint.x | + | dblDiffX |
        //  | sin  cos || m_pEdgeScanLine.ys - m_pStandardPoint.y |   | m_pStandardPoint.y |   | dblDiffY |
        double dblSin = sin(-dblDiffAngle);
        double dblCos = cos(-dblDiffAngle);
        double dblTempX = (m_pStandardPoint->Getx() * (1 - dblCos)) + (m_pStandardPoint->Gety() * dblSin) + dblDiffX;
        double dblTempY = -(m_pStandardPoint->Getx() * dblSin) + (m_pStandardPoint->Gety() * (1 - dblCos)) + dblDiffY;
        pScanLineSeg->Putxs((m_pEdgeScanLine->Getxs() * dblCos) - (m_pEdgeScanLine->Getys() * dblSin) + dblTempX);
        pScanLineSeg->Putys((m_pEdgeScanLine->Getxs() * dblSin) + (m_pEdgeScanLine->Getys() * dblCos) + dblTempY);
        // I_W]
        pScanLineSeg->Putxe((m_pEdgeScanLine->Getxe() * dblCos) - (m_pEdgeScanLine->Getye() * dblSin) + dblTempX);
        pScanLineSeg->Putye((m_pEdgeScanLine->Getxe() * dblSin) + (m_pEdgeScanLine->Getye() * dblCos) + dblTempY);
        
        // ŌoC\
	    m_disp->m_FvxDisplayEx->PutPenColor( RGB(192, 192, 255) );
	    m_disp->m_FvxDisplayEx->DrawData( 0, pScanLineSeg );
        
		try {
			// GbWos
			m_FvxEdge->Execute( m_FvxImage1, pScanLineSeg, &lngCount );
		} catch ( _com_error ) {
			long lngErr = 0;
			CString str;
			m_FvxEdge->GetErrReport( &lngErr );

			switch (lngErr) {
				case 0:
					str = "G[";
					break;
				case 4005:
					str = "p[^Ⴂ܂";
					break;
				case 4006:
					str = "̌^Ⴂ܂";
					break;
				case 4007:
					str = "NULLw肳Ă܂";
					break;
				case 4013:
					str= "̈悪w肳Ă܂";
					break;
				default:
					str= "sȃG[";
					break;
			}
			
			MessageBox(str,"GbWoG[", MB_ICONWARNING | MB_OK);
			return;
        }

        if ( lngCount >= 1 ) {
			// GbW_ŕ\
		    m_disp->m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
                
			// GbW͂P_݂̂Ȃ̂ŁAindexno0
			m_FvxEdge->GetResult( 0, pEdgeResult );
		    m_disp->m_FvxDisplayEx->DrawData( 0, pEdgeResult );
			sResult.Format("\r\nGbW_W  ( %.2f , %.2f )",pEdgeResult->Getx(),pEdgeResult->Gety() );
			m_result = m_result + sResult;

		} else {
			MessageBox("GbW܂ł","GbWo", MB_ICONWARNING | MB_OK);
		}
	}
		
    // ----------------------------------------------------------------
    // ԌvI
    m_FvxPerformanceCounter->StopCount( &dblTime );
    sResult.Format("\r\n\r\n : %.2fms",dblTime);
	m_result = m_result + sResult;

	UpdateData(FALSE);

}

// Tvs
void CGSedgeDlg::OnDosample() 
{

	char szIniFilePath[_MAX_PATH];
	long lngErr = 0;

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CString sFilePath = szIniFilePath;
	sFilePath.Replace("GSedge.exe","sample1.bmp");

    // }X^摜ǂݍ
	try {
		m_FvxFileAccess->PutFilePath( _bstr_t ( sFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
	} catch ( _com_error ) {
		m_FvxFileAccess->GetErrReport( &lngErr );
		if ( lngErr != 0 ) {
			MessageBox("sample1.bmpǂݍ߂܂ł","", MB_ICONWARNING | MB_OK);
			return ;
		}
	}
    
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	MessageBox("}X^摜ǂݍ","", MB_ICONWARNING | MB_OK);
	sFilePath.Replace("sample1.bmp","sample1.pat");
    
    // p^ǂݍ
	try {
		m_FvxPattern1->PutLoadPattrenFileName( _bstr_t (sFilePath) );
		m_FvxPattern1->Load();
	} catch ( _com_error ) {
		m_FvxPattern1->GetErrReport( &lngErr );
		if ( lngErr != 0 ) {
			MessageBox("sample1.patǂݍ߂܂ł","", MB_ICONWARNING | MB_OK);
			return ;
		}
	}
		
	sFilePath.Replace("sample1.pat","sample2.pat");
	try {
		m_FvxPattern2->PutLoadPattrenFileName( _bstr_t (sFilePath) );
		m_FvxPattern2->Load();
	} catch ( _com_error ) {
		m_FvxPattern2->GetErrReport( &lngErr );
		if ( lngErr != 0 ) {
			MessageBox("sample2.patǂݍ߂܂ł","", MB_ICONWARNING | MB_OK);
			return ;
		}
	}

    // GbWoݒ
    m_pEdgeScanLine->Putxs( 300 );
    m_pEdgeScanLine->Putys( 250 );
    m_pEdgeScanLine->Putxe( 400 );
    m_pEdgeScanLine->Putye( 250 );
    
    // ʒu
    OnSetstandard();
	MessageBox("p^Ǎ݁GbWoݒ聕","", MB_ICONWARNING | MB_OK);
    
    // 摜ǂݍ
	sFilePath.Replace("sample2.pat","sample2.bmp");
	try {
		m_FvxFileAccess->PutFilePath( _bstr_t ( sFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
	} catch ( _com_error ) {
		m_FvxFileAccess->GetErrReport( &lngErr );
		if ( lngErr != 0 ) {
			MessageBox("sample2.bmpǂݍ߂܂ł","", MB_ICONWARNING | MB_OK);
			return ;
		}
	}
		
    m_disp->m_FvxDisplayEx->ClearOverlay( -1 );
    m_disp->m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	MessageBox("摜ǂݍ","", MB_ICONWARNING | MB_OK);
    
    // s
    OnExecute();
	MessageBox("ACgGbWos","", MB_ICONWARNING | MB_OK);

}

BOOL CGSedgeDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}
